import processing.serial.*;

Serial myport;

int center = 400;
int gridRes = 20;

int readings = 0;
int drawings = 0;

float[] data = new float[21];

void drawCoordinateSystem(){
  for(int i = center*2; i >= 0; i -=gridRes){
    stroke(209);
    ellipseMode(CENTER);
    ellipse(center,center,i,i);
  }
  
  for(int i = center*2; i >= 0; i -=gridRes){
    stroke(209);
    float angle = radians(i);
    
    float a2 = center + (cos(angle)*(center*2));
    float b2 = center + (sin(angle)*(center*2));
   
    line(center,center,a2,b2);
   
  }
  
  stroke(0);
  line(center,0,center,center*2);
  line(0,center,center*2,center);
}

void setup(){
  size(center*2,center*2);
  background(#ffffff);
  smooth();
  myport = new Serial(this, Serial.list()[2], 9600);
  println(Serial.list()); // list available serial ports

  data[19] = 0;
  data[20] = 0;
  
  // draw the coordinate system
  drawCoordinateSystem();  

}

void draw(){ 
  if(readings == 19){
    
    drawings++;
    
    stroke(#ff0000);
    int u = 0;
    for(int grad = 180; grad < 360; grad += 10){
        float winkel = radians(grad);
        
        float x1 = center + (cos(winkel)*data[u]);
        float y1 = center + (sin(winkel)*data[u]); 
        
        float winkel2 = radians(grad + 10);
         
        float x2 = center + (cos(winkel2)*data[u+1]);
        float y2 = center + (sin(winkel2)*data[u+1]);
        
        line(x1,y1,x2,y2);
        u++;
    }
    if(u > 18){
      u = 0;
    }
    
    if(drawings > 1){ // redraw the coordinate system to ensure that the graphs are not overlaying eachother
      drawCoordinateSystem();
      drawings = 0;    
    }
    
    readings = 0;
  }
}

void serialEvent(Serial myport){
  
  String inString = myport.readStringUntil('\n');
  
  if(inString != null){ // if the string actually contains data
    println("Receiving:" + inString);
    readings++;
    // the received data is stored in the array data[] seperated by a comma
    data[readings] = float(inString);
  }
  
}
 
